package com.sun.corba.se.impl.activation;

import com.sun.corba.se.spi.activation.ORBPortInfo;
import com.sun.corba.se.spi.activation.LocatorPackage.ServerLocation;
import com.sun.corba.se.spi.activation.ServerNotRegistered;
import com.sun.corba.se.spi.activation.ServerHeldDown;
import com.sun.corba.se.spi.activation.NoSuchEndPoint;
import com.sun.corba.se.spi.activation.LocatorHelper;
import org.omg.CORBA.ORB;
import com.sun.corba.se.impl.orbutil.CorbaResourceUtil;
import java.io.PrintStream;

class LocateServer implements CommandHandler
{
    static final int illegalServerId = -1;
    
    LocateServer() {
    }
    
    @Override
    public String getCommandName() {
        return "locate";
    }
    
    @Override
    public void printCommandHelp(PrintStream printStream, boolean b) {
        if (!b) {
            printStream.println(CorbaResourceUtil.getText("servertool.locate"));
        }
        else {
            printStream.println(CorbaResourceUtil.getText("servertool.locate1"));
        }
    }
    
    @Override
    public boolean processCommand(String[] array, ORB orb, PrintStream printStream) {
        int n = -1;
        String str = "IIOP_CLEAR_TEXT";
        try {
            int i = 0;
            while (i < array.length) {
                String s = array[i++];
                if (s.equals("-serverid")) {
                    if (i < array.length) {
                        n = (int)Integer.valueOf(array[i++]);
                    }
                    else {
                        return true;
                    }
                }
                else if (s.equals("-applicationName")) {
                    if (i < array.length) {
                        n = ServerTool.getServerIdForAlias(orb, array[i++]);
                    }
                    else {
                        return true;
                    }
                }
                else {
                    if (!s.equals("-endpointType") || i >= array.length) {
                        continue;
                    }
                    str = array[i++];
                }
            }
            if (n == -1) {
                return true;
            }
            ServerLocation locateServer = LocatorHelper.narrow(orb.resolve_initial_references("ServerLocator")).locateServer(n, str);
            printStream.println(CorbaResourceUtil.getText("servertool.locate2", locateServer.hostname));
            for (int length = locateServer.ports.length, j = 0; j < length; ++j) {
                ORBPortInfo orbPortInfo = locateServer.ports[j];
                printStream.println("\t\t" + orbPortInfo.port + "\t\t" + str + "\t\t" + orbPortInfo.orbId);
            }
        }
        catch (NoSuchEndPoint noSuchEndPoint) {}
        catch (ServerHeldDown serverHeldDown) {
            printStream.println(CorbaResourceUtil.getText("servertool.helddown"));
        }
        catch (ServerNotRegistered serverNotRegistered) {
            printStream.println(CorbaResourceUtil.getText("servertool.nosuchserver"));
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        return false;
    }
}
